#include "stdafx.h"
#include "SpinnerDesign.h"
#include "CColourComboBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


void CColourComboBox::DrawItem(LPDRAWITEMSTRUCT lpDraw)
{
	CDC dc;
	dc.Attach(lpDraw->hDC);

	int itemID = lpDraw->itemID;
	if(lpDraw->itemAction&ODA_FOCUS)
	{
		CRect rc = lpDraw->rcItem;\
		rc.InflateRect(-2,-2);
		dc.DrawFocusRect(&rc);
	}
	if(itemID!=0xffffffff)
	{
		CBrush br(GetItemData(itemID));
		CRect rc = lpDraw->rcItem;
		rc.InflateRect(-3,-3);
		dc.FillRect(&rc,&br);
	}
	dc.Detach();
}

void CColourComboBox::MeasureItem(LPMEASUREITEMSTRUCT lpSize)
{
	lpSize->itemHeight=12;
	lpSize->itemHeight=20;
}

int CColourComboBox::CompareItem(LPCOMPAREITEMSTRUCT lpDraw)
{
	return 0;
}

void CColourComboBox::ReadFromIniSection(LPCSTR szName)
{
	CString strValue = AfxGetApp()->GetProfileString(szName,"0");
	int i=0;
	while(strValue.GetLength())
	{
		AddColour(atoi(strValue));
		char str[20];
		i++;
		strValue=AfxGetApp()->GetProfileString(szName,_itoa(i,str,10));
	}
	if(i==0) // none loaded
	{
		PALETTEENTRY pets[10];
		HDC dc = ::GetDC(GetSafeHwnd());
		GetSystemPaletteEntries(dc,0,10,pets);
		::ReleaseDC(GetSafeHwnd(),dc);
		for(int i=0;i<10;i++)
		{
			AddColour(RGB(pets[i].peRed,pets[i].peGreen,pets[i].peBlue));
		}
	}
}

void CColourComboBox::WriteToIniSection(LPCSTR szName)
{
	for(int i=0;i<GetCount();i++)
	{
		char str[20],stritemno[20];
		int lbval = GetItemData(i);
		_itoa(lbval,str,10);
		AfxGetApp()->WriteProfileString(szName,_itoa(i,stritemno,10),str);
	}
}
