// ColourPicker.cpp : implementation file
//

#include "stdafx.h"
#include "SpinnerDesign.h"
#include "ColourPicker.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CColourPicker dialog


CColourPicker::CColourPicker(CWnd* pParent /*=NULL*/)
	: CDialog(CColourPicker::IDD, pParent)
{
	//{{AFX_DATA_INIT(CColourPicker)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CColourPicker::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CColourPicker)
	DDX_Control(pDX, IDC_LIST1, m_list);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CColourPicker, CDialog)
	//{{AFX_MSG_MAP(CColourPicker)
	ON_BN_CLICKED(IDC_BTNADD, OnBtnadd)
	ON_BN_CLICKED(IDC_BTNDEL, OnBtndel)
	ON_LBN_SELCHANGE(IDC_LIST1, OnSelchangeList1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CColourPicker message handlers

void CColourPicker::OnBtnadd() 
{
	int clr =0;
	if(m_list.GetCurSel()!=-1)
	{
		clr=m_list.GetItemData(m_list.GetCurSel());
	}
	CColorDialog dlg(clr);
	if(dlg.DoModal()==IDOK)
	{
		m_list.AddColour(dlg.GetColor());
	}
}

void CColourPicker::OnBtndel() 
{
	if(m_list.GetCurSel()!=-1)
	{
		int sel = m_list.GetCurSel();
		m_list.DeleteString(sel);
		m_list.SetCurSel(max(0,sel-1));
	}
}

void CColourPicker::OnSelchangeList1() 
{
	GetDlgItem(IDC_BTNADD)->EnableWindow(m_list.GetCurSel()!=-1);
}

BOOL CColourPicker::OnInitDialog() 
{
	CDialog::OnInitDialog();

	if(m_comboClr)
	{
		m_list.ReadFromList(*m_comboClr);
	}

	if(m_list.GetCount()!=0)
	{
		m_list.SetCurSel(0);
		GetDlgItem(IDC_BTNADD)->EnableWindow(true);
	}
	else
	{
		GetDlgItem(IDC_BTNADD)->EnableWindow(false);
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CColourPicker::OnOK() 
{
	if(m_comboClr)
	{
		m_list.WriteToList(*m_comboClr);
	}
	CDialog::OnOK();
}
