
#include "stdafx.h"
#include "SpinnerDesign.h"
#include "SpinnerDesignDlg.h"
#include "ColourPicker.h"
#include "ObjectStorage.h"
#include <math.h>
#include "StorageStructs.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNAMIC(CObjectStorage,CObject)
IMPLEMENT_DYNAMIC(CLineStorage,CObjectStorage)
IMPLEMENT_DYNAMIC(CPolyStorage,CObjectStorage)

void CLineStorage::Draw(CDC *pDC,double scale,double rot_2d,CPoint centre)
{
	POINT tempPoly[MAX_POLY];

	// correct values in loop to x,y locations
	int noCoords = coordinates.GetCount();
	POSITION pos = coordinates.GetHeadPosition();
	int i=0;
	while(pos && i<MAX_POLY)
	{
		AngLenPair p = coordinates.GetNext(pos);
		double len = p.m_len;
		double ang = p.m_ang;
		len *= scale;
		ang += rot_2d;

		tempPoly[i].x = int(sin(ang)*len)+centre.x;
		tempPoly[i].y = int(-(cos(ang)*len))+centre.y;
		i++;
	}
	
	// draw it the right color.
	CPen pen(PS_SOLID,1,RGB(fgred,fggreen,fgblue));
	CBrush brush(RGB(bkred,bkgreen,bkblue));
	CPen *oldpen = pDC->SelectObject(&pen);
	pDC->Polyline(tempPoly,i);
	pDC->SelectObject(oldpen);
}


void CPolyStorage::Draw(CDC *pDC,double scale,double rot_2d,CPoint centre)
{
	POINT tempPoly[MAX_POLY];

	// correct values in loop to x,y locations
	int noCoords = coordinates.GetCount();
	POSITION pos = coordinates.GetHeadPosition();
	int i=0;
	while(pos && i<MAX_POLY)
	{
		AngLenPair p = coordinates.GetNext(pos);
		double len = p.m_len;
		double ang = p.m_ang;
		len *= scale;
		ang += rot_2d;

		tempPoly[i].x = int(sin(ang)*len)+centre.x;
		tempPoly[i].y = int(-(cos(ang)*len))+centre.y;
		i++;
	}
	
	// draw it the right color.
	CPen pen(PS_SOLID,1,RGB(fgred,fggreen,fgblue));
	CBrush brush(RGB(bkred,bkgreen,bkblue));
	CPen *oldpen = pDC->SelectObject(&pen);
	CBrush *oldbrush = pDC->SelectObject(&brush);
	pDC->Polygon(tempPoly,i);
	pDC->SelectObject(oldpen);
	pDC->SelectObject(oldbrush);
}

// throws CFileException
void CObjectStorage::OutputCoordinates(CFile *file)
{
	// create the header.
	struct StorageEntry entry;
	entry.type = (BYTE) GetObjectType();
	entry.noItems = (BYTE) coordinates.GetCount();
	entry.bkred = bkred;
	entry.bkgreen = bkgreen;
	entry.bkblue = bkblue;
	entry.fgred = fgred;
	entry.fggreen = fggreen;
	entry.fgblue = fgblue;

	// allocate enough memory to convert all coordinates into file stream.
	PointEntryPair* coords = new PointEntryPair[coordinates.GetCount()];
	if(coords)
	{
		// convert all our points into file format.
		int i=0;
		POSITION pos = coordinates.GetHeadPosition();
		while(pos)
		{
			AngLenPair point = coordinates.GetNext(pos);
			coords[i].ang=point.m_ang;
			coords[i].len=point.m_len;
			i++;
		}

		// write the header information to the file stream.
		file->Write(&entry,sizeof StorageEntry);
		// write the coordinate information to the file.
		file->Write(coords, (sizeof PointEntryPair)*coordinates.GetCount());

		// clean up
		delete coords;
	}
	else ::MessageBox(::GetFocus(),"Memory allocation problem","Memory Problem",MB_OK|MB_ICONEXCLAMATION);
}
